salt-ssh

# `salt-ssh`

## Synopsis

> salt-ssh '*' [ options ] sys.doc

> salt-ssh -E '.*' [ options ] sys.doc cmd

## Description

Salt ssh allows for salt routines to be executed using only ssh for transport

## Options

`-r````,` `--raw````,` `--raw-shell```

  Execute a raw shell command.

`--roster-file```

  Define which roster system to use, this defines if a database backend, scanner, or custom roster system is used. Default is the flat file roster.

`--refresh````,` `--refresh-cache```

  Force a refresh of the master side data cache of the target's data. This is needed if a target's grains have been changed and the auto refresh timeframe has not been reached.

`--max-procs```

  Set the number of concurrent minions to communicate with. This value defines how many processes are opened up at a time to manage connections, the more running process the faster communication should be, default is 25.

`--passwd```

  Set te default password to attempt to use when authenticating.

`--key-deploy```

  Set this flag to attempt to deploy the authorized ssh key with all minions. This combined with --passwd can make initial deployment of keys very fast and easy.

`--version```

  Print the version of Salt that is running.

`--versions-report```

  Show program's dependencies and version number, and then exit

`-h````,` `--help```

  Show the help message and exit

`-c` `CONFIG_DIR``,` `--config-dir``=CONFIG_dir`

  The location of the Salt configuration directory. This directory contains the configuration files for Salt master and minions. The default location on most systems is `/etc/salt`.

### Target Selection

`-E````,` `--pcre```

  The target expression will be interpreted as a PCRE regular expression rather than a shell glob.

`-L````,` `--list```

  The target expression will be interpreted as a comma-delimited list; example: server1.foo.bar,server2.foo.bar,example7.quo.qux

`-G````,` `--grain```

  The target expression matches values returned by the Salt grains system on the minions. The target expression is in the format of '<grain value>:<glob expression>'; example: 'os:Arch*'

  This was changed in version 0.9.8 to accept glob expressions instead of regular expression. To use regular expression matching with grains, use the --grain-pcre option.

`--grain-pcre```

  The target expression matches values returned by the Salt grains system on the minions. The target expression is in the format of '<grain value>:< regular expression>'; example: 'os:Arch.*'

`-N````,` `--nodegroup```

  Use a predefined compound target defined in the Salt master configuration file.

`-R````,` `--range```

  Instead of using shell globs to evaluate the target, use a range expression to identify targets. Range expressions look like %cluster.

  Using the Range option requires that a range server is set up and the location of the range server is referenced in the master configuration file.

### Logging Options

Logging options which override any settings defined on the configuration files.

`-l` `LOG_LEVEL``,` `--log-level``=LOG_LEVEL`

  Console logging log level. One of `all`, `garbage`, `trace`, `debug`, `info`, `warning`, `error`, `quiet`. Default: `warning`.

`--log-file``=LOG_FILE`

  Log file path. Default: /var/log/salt/ssh.

`--log-file-level``=LOG_LEVEL_LOGFILE`

  Logfile logging log level. One of `all`, `garbage`, `trace`, `debug`, `info`, `warning`, `error`, `quiet`. Default: `warning`.

### Output Options

`--out```

  Pass in an alternative outputter to display the return of data. This outputter can be any of the available outputters:

  > `grains`, `highstate`, `json`, `key`, `overstatestage`, `pprint`, `raw`, `txt`, `yaml`

  Some outputters are formatted only for data returned from specific functions; for instance, the `grains` outputter will not work for non-grains data.

  If an outputter is used that does not support the data passed into it, then Salt will fall back on the `pprint` outputter and display the return data using the Python `pprint` standard library module.

  Note

  If using `--out=json`, you will probably want `--static` as well. Without the static option, you will get a JSON string for each minion. This is due to using an iterative outputter. So if you want to feed it to a JSON parser, use `--static` as well.

`--out-indent` `OUTPUT_INDENT``,` `--output-indent` `OUTPUT_INDENT`

  Print the output indented by the provided value in spaces. Negative values disable indentation. Only applicable in outputters that support indentation.

`--out-file``=OUTPUT_FILE``,` `--output-file``=OUTPUT_FILE`

  Write the output to the specified file.

`--no-color```

  Disable all colored output

`--force-color```

  Force colored output

## See also

salt(7) salt-master(1) salt-minion(1)

Current Salt release: 0.17.1

### Table Of Contents

- `salt-ssh`
  - Synopsis
  - Description
  - Options
    - Target Selection
    - Logging Options
    - Output Options
  - See also

#### Previous topic

`salt-run`

#### Next topic

`salt-syndic`

### Quick search

Enter search terms or a module, class or function name.

### Upcoming SaltStack Events

My conferences on Lanyrd